Array.prototype.find = function(searchStr) {
  var returnArray = false;
  for (i=0; i<this.length; i++) {
    if (typeof(searchStr) == 'function') {
      if (searchStr.test(this[i])) {
        if (!returnArray) { returnArray = [] }
        returnArray.push(i);
      }
    } else {
      if (this[i]===searchStr) {
        if (!returnArray) { returnArray = [] }
        returnArray.push(i);
      }
    }
  }
  return returnArray;
}

function PList(size){

        var init = function(){
                //public
                _pub.getAItemInx = getAItemInx;
                _pub.setAItem = setAItem;
                _pub.nextAItem = nextAItem;
                _pub.prevAItem = prevAItem;
                _pub.getVItemInx = getVItemInx;
                _pub.setVItem = setVItem;
                _pub.nextVItem = nextVItem;
                _pub.prevVItem = prevVItem;
                _pub.nextPlayMode = nextPlayMode;
                _pub.getPlayModeTitle = getPlayModeTitle;
		_pub.reload = reload;
		_pub.getPlayModeIcon = getPlayModeIcon;
		_pub.getPlayModeSmallIcon = getPlayModeSmallIcon;
		_pub.getPlayModeName = getPlayModeName;
		_pub.setPlayMode = setPlayMode;
		reload(m_length);

                //private
                m_play_mode = m_play_modes.list_loop;
        }

        //public
     	var setPlayMode = function(play_mode){
                m_play_mode = m_play_modes[play_mode] || m_play_mode;
        }

     	var getPlayModeName = function(){
                return m_play_mode.name;
        }

	var getPlayModeIcon = function(){
		return m_play_mode.icon();
	}
	var getPlayModeSmallIcon = function(){
		return m_play_mode.s_icon();
	}

	var reload = function(size){
		if (size<=0)
			return;
        	m_length = size;
        	m_rand_inxs = [];
		JSTV.System.DebugString("Calling garbageCollect()");
		garbageCollect();

                for (var i=0; i<m_length; ++i){
                        m_rand_inxs[i] = i;
                }
                for(var i = m_length-1; i>0; --i){
                        var j = parseInt(Math.random() * i) + 1;
                        var x = m_rand_inxs[i];
                        m_rand_inxs[i] = m_rand_inxs[j];
                        m_rand_inxs[j] = x
                }
        	m_aitem.cur=0;
		m_aitem.cur_rand=0;
		m_aitem.offset_rand=0;
        	m_vitem.cur=0;
		m_vitem.cur_rand=0;
		m_vitem.offset_rand=0;
	}

        var nextPlayMode = function(){
                m_play_mode = m_play_mode.next();
                return m_play_mode.title;
        }

        var getPlayModeTitle = function(){
                return m_play_mode.title;
        }

        var getAItemInx = function(){
                return m_aitem.cur;
        }

        var setAItem = function(inx){
		m_aitem.cur = m_aitem.cur_rand = makeItemInx(inx); 
		m_aitem.offset_rand = 0;
                return m_aitem.cur;
        }

        var nextAItem = function(){
                m_aitem.cur = m_play_mode.next_aitem();
                return m_aitem.cur;
        }

        var prevAItem = function(){
                m_aitem.cur = m_play_mode.prev_aitem();
                return m_aitem.cur;
        }

        var getVItemInx = function(){
                return m_vitem.cur;
        }

        var setVItem = function(inx){
		m_vitem.cur = m_vitem.cur_rand = makeItemInx(inx); 
		m_vitem.offset_rand = 0;
                return m_vitem.cur;
        }

        var nextVItem = function(){
                m_vitem.cur = m_play_mode.next_vitem();
                return m_vitem.cur;
        }

        var prevVItem = function(){
                m_vitem.cur = m_play_mode.prev_vitem();
                return m_vitem.cur;
        }

        //private
        var _pub = this;
        var m_play_mode = null;
        var m_length = size;
        var m_rand_inxs = null;
        var m_aitem = { cur:0 , cur_rand:0, offset_rand:0}
        var m_vitem = { cur:0 , cur_rand:0, offset_rand:0}
	var m_imgs = new Object;

	var loadImg = function(fname){
		var img = m_imgs[fname];
		if (!img){
			img = m_imgs[fname] = new Image();
			img.src = fname; 
		}
		return img;
	}

        var makeItemInx = function(inx){
                if (typeof inx != "number" || inx<0 || inx>=m_length)
                        return nullItem();
                return inx;
        }
        var nullItem = function(){
                return -1;
        }

        var curActiveItem = function(){
                return m_aitem.cur;
        }

        var nextItem = function(prms){
                var item = m_aitem;
                var delta = prms && prms.delta ? prms.delta : 1;
                if (prms){
                        item = prms.vitem ? m_vitem : m_aitem;
                        var inx = item.cur;
                        var offset = prms.rand ? item.offset_rand + delta : item.cur + delta;
                        if (prms.rand){
                                if (m_rand_inxs[item.cur_rand]!=item.cur)
                                        item.cur_rand = m_rand_inxs.find(item.cur)[0];
                                inx = item.cur_rand;
                        }
                        if (item.cur!=nullItem()){
                                var tmp_delta = delta;
                                if (inx + delta < 0)
                                        tmp_delta = m_length - ((inx - delta) % m_length);
                                inx = (inx+tmp_delta) % m_length;

                                if (!prms.loop && ((delta<0 && offset<0) || (delta>0 && offset>=m_length)))
                                                inx = getNullItem();
                        }
                        if (inx!=getNullItem()){
                                item.cur = prms.rand ? m_rand_inxs[inx] : inx;
                                item.offset_rand = prms.rand ? offset : 0;
                        }
                        else
                                item.cur = inx;
                }
                else{
                        if (item.cur != nullItem()){
                                item.cur += delta;
                                item.offset_rand = 0;
                        }
                }
		return makeItemInx(item.cur);
        }

        var prevItem = function(prms){
                if (prms){
                        prms.delta = -1;
                }
                else{
                        prms = { delta:-1 };
                }
                return nextItem(prms);
        }

        var m_play_modes = {
                            single_once:
                            {
                                next_aitem : function() { return nullItem() },
                                prev_aitem : function() { return nullItem() },
                                next_vitem : function() { return nextItem({ loop:1, vitem:1 }) },
                                prev_vitem : function() { return prevItem({ loop:1, vitem:1 }) },
                                next       : function() { return playModeRef("single_loop") },
                                icon       : function() { return loadImg("flist/flist_mode_p.png")},
                                s_icon     : function() { return loadImg("images/pl_mode_p.png")},
                                title      : "Single - Once",
                            },
                            single_loop:
                            {
                                next_aitem : function() { return curActiveItem() },
                                prev_aitem : function() { return curActiveItem() },
                                next_vitem : function() { return nextItem({ loop:1, vitem:1 }) },
                                prev_vitem : function() { return prevItem({ loop:1, vitem:1 }) },
                                next       : function() { return playModeRef("list_once") },
                                icon       : function() { return loadImg("flist/flist_mode_p_loop.png")},
                                s_icon     : function() { return loadImg("images/pl_mode_p_loop.png")},
                                title      : "Single - Loop",
                            },
                            list_once:
                            {
                                next_aitem : function() { return nextItem() },
                                prev_aitem : function() { return prevItem() },
                                next_vitem : function() { return nextItem({ loop:1, vitem:1 }) },
                                prev_vitem : function() { return prevItem({ loop:1, vitem:1 }) },
                                next       : function() { return playModeRef("list_loop") },
                                icon       : function() { return loadImg("flist/flist_mode_pd.png")},
                                s_icon     : function() { return loadImg("images/pl_mode_pd.png")},
                                title      : "List - Once",
                            },
                            list_loop:
                            {
                                next_aitem : function() { return nextItem({ loop:1 }) },
                                prev_aitem : function() { return prevItem({ loop:1 }) },
                                next_vitem : function() { return nextItem({ loop:1, vitem:1 }) },
                                prev_vitem : function() { return prevItem({ loop:1, vitem:1 }) },
                                next       : function() { return playModeRef("shuffle_once") },
                                icon       : function() { return loadImg("flist/flist_mode_pd_loop.png")},
                                s_icon     : function() { return loadImg("images/pl_mode_pd_loop.png")},
                                title      : "List - Loop",
                            },
                            shuffle_once:
                            {
                                next_aitem : function() { return nextItem({ rand:1 }) },
                                prev_aitem : function() { return prevItem({ rand:1 }) },
                                next_vitem : function() { return nextItem({ loop:1, vitem:1 }) },
                                prev_vitem : function() { return prevItem({ loop:1, vitem:1 }) },
                                next       : function() { return playModeRef("shuffle_loop") },
                                icon       : function() { return loadImg("flist/flist_mode_ps.png")},
                                s_icon     : function() { return loadImg("images/pl_mode_ps.png")},
                                title      : "Shuffle - Once",
                            },
                            shuffle_loop:
                            {
                                next_aitem : function() { return nextItem({ rand:1, loop:1 }) },
                                prev_aitem : function() { return prevItem({ rand:1, loop:1 }) },
                                next_vitem : function() { return nextItem({ loop:1, vitem:1 }) },
                                prev_vitem : function() { return prevItem({ loop:1, vitem:1 }) },
                                next       : function() { return playModeRef("single_once") },
                                icon       : function() { return loadImg("flist/flist_mode_ps_loop.png")},
                                s_icon     : function() { return loadImg("images/pl_mode_ps_loop.png")},
                                title      : "Shuffle - Loop",
                            },
        }

        for (var mode in m_play_modes){
                if (m_play_modes.hasOwnProperty(mode)){
                        m_play_modes[mode]._ = m_play_modes;
                        m_play_modes[mode].name = mode;
                }
	}

        //methods
        var playModeRef = function(mode){
                return m_play_modes[mode] ? m_play_modes[mode] : m_play_modes.single_once;
        }

        var getNullItem = function(prms){
                return -1;
        }

        init();
}


