var scr_width = JSTV.Video.GetBrowseRegionWidth();
var scr_height = JSTV.Video.GetBrowseRegionHeight();
var shift = (scr_width-720)/2;
var d_url = window.location.toString();
var d_base_url = d_url.substring(0, d_url.lastIndexOf("/"));

var vol_data = {"meta":	{ "steps"	: 32, 
			  "timeout"	: 2000,
			  "top_x"	: 654 + shift,
			  "top_y"	: 79,
			  "base_url"	: d_base_url + "/skin/default/vol_control/",
			},

		"bar":	{ "x_offset"	:0,
			  "y_offset"	:0,
			  "width_height":27,
			  "vertical"	:true,
 
			  "head": { "length"	: 8, 
				    "img"	: "vol_head.png", 
				  },
			  "body": { "top_margin": 4,
				    "bot_margin": 18, 
			   	    "img_bg"	: "vol_bg.png",
			  	    "nitems"	: 16, 

	 	     		    "item": { 	"length"	: 9, 
			  			"space"		: 4,
			  			"img_on"	: ["vol_on.png", "vol_on.png",
								   "vol_on.png", "vol_on.png",
								   "vol_on.png", "vol_on.png",
								   "vol_on.png", "vol_on_high.png"],

			  			"img_off"	: ["vol_off.png"],
			  			"img_mute"	: ["vol_mute.png"],
					    },
				  },
			  "tail": 	{ "length"	: 8, 
				  	  "img"		: "vol_tail.png",
					},
		        },

		 "mute":{ "x_offset"	: 0,
			  "y_offset"	: 220,
			  "width"	: 27,
			  "height"	: 18,
			  "img_on"	: "vol_mute_on.png",
			  "img_off"	: "vol_mute_off.png",
			},
		};

var m_menulist ={"meta":{ "top_x"	: 241+shift,
			  "top_y"	: 110,
			  "base_url"	: d_base_url + "/skin/default/list_box/",
			},
		"list":	{ "x_offset"	:0,
			  "y_offset"	:62,
			  "nitems"	:6,
 
			  "item": { "width": 238,
				    "height": 33, 
				    "img_bg": "label_bg.png",

				    "text_style" : "font-size:7pt; font-weight:bold; color:#000000;",
				  },

			  "caret":{ "x_offset"  : -16,
				    "width"	: 269,
				    "height"	: 27, 
				    "img_on"	: "caret_on.png",
				    "img_off"	: "caret_off.png",
				  },
		         },

		"title": { "x_offset"	: 0,
			   "y_offset"	: 10,
			   "width": 238,
			   "height": 30, 
			   "img_bg": "label_bg.png",
			   "text_style" : "font-size:8pt; font-weight:bold; color:#c65d00;",
			 },
	     };


var m_background = { "meta"  : { "top_x"	: 205+shift,
			         "top_y"	: 110,
			         "width"	: 310,
			         "height"	: 163,
				 "img"		: d_base_url + "/skin/default/list_box/bg.png",
			       },
	           };
 


var listbox_data = {  "menu_list"	: m_menulist,
			"background"	: m_background,
	             };


var m_ninput= { "meta"   : { "top_x"    : 235+shift,
                            "top_y"     : 170,
                            "height"    : 33,
                            "base_url"  : d_base_url + "/skin/default/ninput_box",
                          },
               "input"  : { "text_style": "font-size:8pt; font-weight:bold; color:#008000;",
                            "img_bg" : "caret_on.png",
                            "width"     : 250,
                          },
             };

var m_ni_tbox = { "meta"  : {  "top_x"  : 235+shift,
                            "top_y"     : 235,
                            "height"    : 80,
                            "width"     : 250,
                            "base_url"  : d_base_url + "/skin/default/ninput_box",
                          },
                "text"  : { "def_style" : "font-size:6pt; font-weight:bold; color:#000000;",
                            "def_value" : "",
                          },
             };

var m_ni_title= { "meta"   : { "top_x"  : 235+shift,
                            "top_y"     : 118,
                            "height"    : 30,
                            "base_url"  : d_base_url + "/skin/default/ninput_box",
                          },
               "label"  : { "text_style": "font-size:7pt; font-weight:bold; color:#c65d00;",
                            "img_bg" : "label_bg.png",
                            "width"     : 250,
                          },
             };

var m_ni_background = { "meta"  : { "top_x"     : 205+shift,
                                 "top_y"        : 110,
                                 "width"        : 310,
                                 "height"       : 291,
                                 "img"          : d_base_url + "/skin/default/ninput_box/bg.png",
                               },
                   };



var ninputbox_data = {  "input_line"    : m_ninput,
                        "title"         : m_ni_title,
                        "description"   : m_ni_tbox,
                        "background"    : m_ni_background,
                     };

var m_logo_data = { "meta"  : { "top_x"     : 532+shift,
                    	        "top_y"     : 450,
                    		"height"    : 33,
				"base_url"  : d_base_url + "/misc",
                  	      },
                    "icon"  : { "width"     : 117,
                            	"img"       : "logo.png",
                              },
        	 };


