self.name="edit"; 



//globals
var edit_obj = new Object();
edit_obj.curr_choice;
edit_obj.scr_size = 4;
edit_obj.options_no;
edit_obj.real_last;	//determined according to the actual no. of options. in this case, there are 3, so the real last index is 2.
			//index 3 serves only as a dummy 
var edit_options = new Array();

//windows handles, windows-related vars
var edit_win = undefined;
var edit_text_win = undefined; 
var edit_lines_imgs_win = undefined;   
var edit_wins_left = 3; 
var edit_all_wins_done = false;


//images handles
var edit_lines_imgs_arr = new Array(); 
var edit_img_bg;  

var edit_mode = false;	//whether system info is hidden or shown. when the page first loads, it is hidden. 
var edit_focus_mode = false;	//whether system info is in focus. when the page first loads, it's not. (focus should be done in the "done" function)
var edit_common_kh = undefined; 
var edit_done_func = new Function();
var edit_ret_func = new Function();
var prev_kh;
var edit_prefix = "";
edit_initial_x = 0; 
edit_initial_y = 0;

               
function edit_load_imgs()
{       
	//grey line (off)
	edit_lines_imgs_arr[0] = new Image();
	edit_lines_imgs_arr[0].src = "edit_images/edit_btn_off.png"; 	
	//blue line (on), no arrows
	edit_lines_imgs_arr[1] = new Image();
	edit_lines_imgs_arr[1].src = "edit_images/edit_btn_on.png"; 
	//blue line (on), up arrow 
	edit_lines_imgs_arr[2] = new Image();
	edit_lines_imgs_arr[2].src = "edit_images/edit_btn_on_up.png"; 
	//blue line (on), down arrow 
	edit_lines_imgs_arr[3] = new Image();
	edit_lines_imgs_arr[3].src = "edit_images/edit_btn_on_down.png"; 
	//blue line (on), both arrows
	edit_lines_imgs_arr[4] = new Image();
	edit_lines_imgs_arr[4].src = "edit_images/edit_btn_on_up_down.png"; 
	

		         	
}



function empty_keyhandler()
{
	return false;
}


//this function is executed from edit_lines_imgs.html, in postload. (but b4 opening the text window).
//it sets the src property of the images in edit_lines_imgs.html to either
//"line off" or "line on"
function edit_put_imgs(win_name, out_doc)
{  	
    var imgs = out_doc.images;
    //JSTV.System.DebugString("imgs length: " + imgs.length); 
    var i = 0;
    for (i = 0; i < edit_obj.scr_size; i++)
    { 
    	//JSTV.System.DebugString(imgs[i].name);	
    	imgs[i].src = edit_lines_imgs_arr[0].src;
    	//JSTV.System.DebugString(i+ ": " + imgs[i].src);
    }                             
    //the images need to be prefixed in order to be used in the scroll function. they don't need to be prefixed when loading,
    //so this is done only now:
    for (i = 0; i < edit_lines_imgs_arr.length; ++i)
    { 
    	edit_lines_imgs_arr[i].src = edit_prefix + edit_lines_imgs_arr[i].src;
    }
    

}


//this function is executed from edit_lines_imgs.html
//it writes the html of the table which comprises the content lines in the edit window. (currently 4 lines)
function edit_put_lines_imgs(win_name, out_doc)
{       
	JSTV.System.DebugString("edit_put_lines_imgs");
	JSTV.System.DebugString("win_name: " + win_name); 
        out_doc.write("<table border='0' cellpadding='0' cellspacing='0'>");     
      
	for (i = 0; i < edit_obj.scr_size; i++)
	{		
		out_doc.write("<tr>");		
		out_doc.write("<td width='247' height='26'><img name='line"+i+"' width='247' height='26' src=''/></td>");		
	        out_doc.write("</tr>");   
	        if (i != edit_obj.scr_size - 1)
	        {
			out_doc.write("<tr><td width='247' height='2'></td></tr>");	//the black border between the lines
		}
	}
	out_doc.write("</table>");		 	
}
 
//this function is executed fron edit.html
//it sets the src property of the image in edit.html to the required background image
//TODO: check if the "ok" and "cancel" buttons should be seperated as well, to pushed and unpushed, and then their line should be seperated as well... 
function edit_put_edit_img(win_name, out_doc)
{ 
	var edit_img = out_doc.images; 
	//JSTV.System.DebugString(edit_img[0].name);
	//TODO: some checks for this line...
	edit_img[0].src = edit_img_bg.src;  
	//JSTV.System.DebugString(edit_img[0].src);
}


function edit_write_html(win_name, out_doc)
{  

	if (win_name == "edit_win")
	{ 
		out_doc.write("<form name='edit_form' id='001'>");
		out_doc.write("<table border='0' cellpadding='0' cellspacing='0'>");
	         
	        out_doc.write("<tr>");                       
		out_doc.write("<td width='256' height='176'><img name='edit_bg' width=256 height=176 src='edit_images/edit_bg_empty.png'/>");                                
		out_doc.write("</td></tr>"); 

		out_doc.write("</table></form>");	
	}
}



function edit_open_lines_imgs()
{
	var x = edit_initial_x + 5;
	var y = edit_initial_y + 34;
	edit_lines_imgs_win  = window.open(edit_prefix + "edit_lines_imgs.html", "edit_lines_imgs_win", "takefocus=no,screenx="+x+",screeny="+y+",width=247,height=110");
}
 
function edit_open_edit_text()
{      
	var x = edit_initial_x + 10;
	var y = edit_initial_y + 34;
	edit_text_win = window.open(edit_prefix + "edit_text_win.html", "edit_text_win", "takefocus=no,screenx="+x+",screeny="+y+",width=247,height=110");	
} 

function edit_write_text(win_name, out_doc)
{   
	JSTV.System.DebugString("in write text. win_name: " + win_name); 
	//JSTV.System.DebugString("in write text. out_doc: " + out_doc);
	var aux; 
	if(win_name == "edit_text_win")
	{ 
		out_doc.write("<table border='0' cellpadding='0' cellspacing='0'>");
		out_doc.write("<form name='edit_text_form'>");  
		for (i = 0; i < edit_obj.scr_size; i++) 
		{		                        
			aux = "option" + i; 
			out_doc.write("<tr>");
			out_doc.write("<td width='10' height='26'></td>");
			out_doc.write("<td width='237' height='26' valign='middle'>");		

			if (skin=="Dark")
				out_doc.write('<input name=' + aux + ' type="button" height="26" width="237" selimage="edit_images/empty1.png" borderimage="edit_images/empty1.png" style="font-size:8pt;font-weight:bold;color:#ffffff" value=""  >');
			else
				out_doc.write('<input name=' + aux + ' type="button" height="26" width="237" selimage="edit_images/empty1.png" borderimage="edit_images/empty1.png" style="font-size:8pt;font-weight:bold;color:#010101" value=""  >');

			out_doc.write("</td></tr>");
			if (i != edit_obj.scr_size - 1)
	        	{
				out_doc.write("<tr><td width='247' height='2' colspan='2'></td></tr>");	//the black border between the lines
			}
		}
		out_doc.write("</form></table>"); 
	}	
}


function edit_switch_imgs(direction)
{
	var cur = edit_obj.curr_choice;
	var x = edit_lines_imgs_win.document.images;
	JSTV.System.DebugString("edit_lines_imgs_win contains " + x.length + " images");
} 


function edit_window_done(name)
{  
	JSTV.System.DebugString("WINDOW_DONE:" + name);
	edit_wins_left--;
	JSTV.System.DebugString("wins left:" + edit_wins_left);
	if (edit_wins_left == 0)
	{ 
		JSTV.System.DebugString("All Windows Done");
		edit_all_wins_done = true;
		edit_done_func();
	}
}

// sets the document onkeypress function back to the keyhandler which was in use before focus
function edit_doBlur()
{  
   if (edit_focus_mode) 
   {            
   	//document.onkeypress=edit_common_kh; 
   	document.onkeypress = prev_kh;
   	edit_focus_mode = false;            
   	JSTV.System.DebugString("---end Doblur---");
   }
}

function edit_doFocus(kh)
{  
   //if (!edit_focus_mode)
   //{  
   	prev_kh = document.onkeypress;
   	document.onkeypress=edit_keyhandler;
   	edit_common_kh = kh; 
   	edit_focus_mode = true;
   	JSTV.System.DebugString("---end DoFocus---");
   //}
}

function edit_doInit(prefix, func, x, y)
{    
	edit_prefix = prefix;
	edit_load_imgs();                        
	edit_done_func = func;  
	edit_initial_x = x;                 
	edit_initial_y = y;
			
        edit_win = window.open(edit_prefix + "edit.html", "edit_win", "takefocus=no,screenx="+x+",screeny="+y+",width=256,height=176");
	JSTV.System.DebugString("---end DoInit---");

}      

//write the actual values in the text table
function edit_doLoad(arr, def_val, ret_func)
{   
	var i;       
	var aux;
	edit_obj.curr_choice = def_val;
	edit_obj.real_last = arr.length - 1;	//determined according to the actual no. of options.
	edit_ret_func = ret_func;
	edit_options = arr.slice(0);
	//extend the array til the next multiple of 4, fill with dummies. 
	// TO DO: check if the dummies are really needed 
	var extra;
	switch (arr.length % edit_obj.scr_size) 
	{                                                
		case 3:
		  extra = 1;
		  break;
		case 2:
		  extra = 2;
		  break;
		case 1:
	          extra = 3;
	          break;
	        case 0:
	           extra = 0;
	           break;
	        default:
	           break;	  	
	}
	for (i = arr.length; i < arr.length + extra; i++)
	{
	       edit_options[i] = "";
	}
	edit_obj.options_no = edit_options.length;
	JSTV.System.DebugString("len:"+edit_options.length);		
	for (i = 0; i < edit_obj.scr_size; ++i)
	{
		JSTV.System.DebugString("opt:"+edit_options[i]);		
		aux = "option" + i;  
		edit_text_win.document.edit_text_form[aux].value = "#L" + edit_options[i]; 
		
	}
	//handle the defualt selected line
	var imgs = edit_lines_imgs_win.document.images;
	for (i = 0; i < edit_obj.scr_size; i++)
	{
		//first set all lines as not selected (needed for consecutive runs of doLoad, so the last selected value won't stay)
		imgs[i].src = edit_lines_imgs_arr[0].src;
	}
	imgs[edit_obj.curr_choice].src = edit_lines_imgs_arr[1].src;
	

	
	JSTV.System.DebugString("---end DoLoad---"); 
}

// shows the system info windows.
// this function doesn't handle any keyhandler issues, but assumes they're dealt with elsewhere!
function edit_doToFront()
{
	edit_mode = true;
	if (edit_win)
	{             
		//JSTV.System.DebugString("in sinfo_doShow. edit_win exists");
		edit_win.toFront();
		if (edit_lines_imgs_win)
		{ 
			//JSTV.System.DebugString("sinfo_doShow. edit_lines_imgs_win exists");	
			edit_lines_imgs_win.toFront();
		} 
		else
		{
			JSTV.System.DebugString("edit_doToFront. Warning: edit_lines_imgs_win not found, nothing to show");
		} 
		if (edit_text_win) 
		{                 
			//JSTV.System.DebugString("edit_doToFront. edit_text_win exists");
			edit_text_win.toFront();  
		} 
		else
		{
			JSTV.System.DebugString("edit_doToFront. Warning: edit_text_win not found, nothing to show");
		}
	
	}
	else
	{
		JSTV.System.DebugString("edit_doToFront. Warning: edit not found, nothing to show");
	}
	JSTV.System.DebugString("---end DoToFront---");   
}

// hides the system info windows.
// this function doesn't handle any keyhandler issues, but assumes they're dealt with elsewhere!
function edit_doToBack()
{
	edit_mode = false;
	if (edit_win)
	{ 
		edit_win.toBack();
	
		if (edit_lines_imgs_win)
		{  
			edit_lines_imgs_win.toBack();
		}
		else
		{
			JSTV.System.DebugString("edit_doToBack. Warning: edit_lines_imgs_win not found, nothing to hide");
		} 
		if (edit_text_win)
		{
			edit_text_win.toBack();  
		} 
		else
		{
			JSTV.System.DebugString("edit_doToBack. Warning: edit_text_win not found, nothing to hide");
		}
		
	}
	else
	{
		JSTV.System.DebugString("edit_doToBack. Warning: edit_win not found, nothing to hide");
	}
	JSTV.System.DebugString("---end DoToBack---");
}    

// currently, this function only highlights the line we just moved to.
// since the no. of options doesn't require scrolling through screens, there's no handling with changing the presented text (yet)
//TO DO: take care of the above
function edit_scroll()
{
	if (edit_lines_imgs_win)
	{
		var imgs = edit_lines_imgs_win.document.images;			
		switch(edit_obj.curr_choice)
		{     
		case 0:
			imgs[0].src = edit_lines_imgs_arr[1].src;
			imgs[1].src = edit_lines_imgs_arr[0].src;
			imgs[2].src = edit_lines_imgs_arr[0].src;
			imgs[3].src = edit_lines_imgs_arr[0].src; 
			break;
		case 1:
			imgs[0].src = edit_lines_imgs_arr[0].src;
			imgs[1].src = edit_lines_imgs_arr[1].src;
			imgs[2].src = edit_lines_imgs_arr[0].src;
			imgs[3].src = edit_lines_imgs_arr[0].src; 
			break; 
		case 2:
			imgs[0].src = edit_lines_imgs_arr[0].src;
			imgs[1].src = edit_lines_imgs_arr[0].src;
			imgs[2].src = edit_lines_imgs_arr[1].src;
			imgs[3].src = edit_lines_imgs_arr[0].src;  
			break; 
		case 3:
			imgs[0].src = edit_lines_imgs_arr[0].src;
			imgs[1].src = edit_lines_imgs_arr[0].src;
			imgs[2].src = edit_lines_imgs_arr[0].src;
			imgs[3].src = edit_lines_imgs_arr[1].src;  
			break;
		default:
			break;			
		} 
	}
	else
	{
		JSTV.System.DebugString("edit_scroll. Error-edit text window not found");
	}
	
}

function edit_keyhandler(e)
{        
	JSTV.System.DebugString("in edit_keyhandler");
	Key = e.which;
	
	switch (Key)
    	{
	case JSTV.Device.kbd.DOWN:
		//JSTV.System.DebugString("b4: " + edit_obj.curr_choice);
		if (edit_obj.curr_choice < edit_obj.options_no - 1)
		{
			if (edit_obj.curr_choice < edit_obj.real_last)
			{
				++edit_obj.curr_choice; 
			}
			//JSTV.System.DebugString("after: " + edit_obj.curr_choice); 
			//TO DO: add handling more than 4 options (in edit_options) (needed?)
			edit_scroll();
		}
		break; 
	case JSTV.Device.kbd.UP: 
		//JSTV.System.DebugString("b4: " + edit_obj.curr_choice);
		if (edit_obj.curr_choice > 0)
		{
			--edit_obj.curr_choice;
			edit_scroll();
		}
		//JSTV.System.DebugString("after: " + edit_obj.curr_choice);                    
		break; 
	case JSTV.Device.kbd.OK:
		edit_ret_func(edit_obj.curr_choice);
		break;
	case JSTV.Device.kbd.PREVIOUS:
	case JSTV.Device.kbd.ESC:
		edit_ret_func(-1);
		break;  
	default:
		break;
	}
	if (edit_common_kh)
	{
		return edit_common_kh(e);
	}
	else
	{
		JSTV.System.DebugString("edit_keyhandler. Warning: no common keyhandler is set.");
	}
	
}
